/*	
 *	clipdlst.c
 *
 *	[eBeBF_uNXg
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2015 Naoyuki Sawa
 *
 *	* Tue Jan 06 21:26:41 JST 2015 Naoyuki Sawa
 *	- VK쐬B
 *	- u[eBeBF_uNXgvAclipmisc.*clipdlst.*֕܂B
 *	  gppx͍̂ŁAʂȃNh߂ƌAW[ĕՂ邽߂łB
 *	* Wed Jan 07 00:30:50 JST 2015 Naoyuki Sawa
 *	- InitializeListHead(),IsListEmpty(), RemoveHeadList(), RemoveTailList(),RemoveEntryList(),InsertHeadList(),InsertTailList()Asm܂B
 *	  C:100oCgAsm:72oCg ɂȂ܂B28oCgߖł܂B
 */
#include "clip.h"

/*****************************************************************************
 *	[eBeBF_uNXg
 *****************************************************************************/

#ifndef PIECE
void InitializeListHead(LIST_ENTRY* ListHead) {
	ListHead->Flink = ListHead->Blink = ListHead;
}
int IsListEmpty(LIST_ENTRY* ListHead) {
	return ListHead->Flink == ListHead;
}
LIST_ENTRY* RemoveHeadList(LIST_ENTRY* ListHead) {
	LIST_ENTRY* Head = ListHead->Flink;
	RemoveEntryList(Head);
	return Head;
}
LIST_ENTRY* RemoveTailList(LIST_ENTRY* ListHead) {
	LIST_ENTRY* Tail = ListHead->Blink;
	RemoveEntryList(Tail);
	return Tail;
}
void RemoveEntryList(LIST_ENTRY* Entry) {
	LIST_ENTRY* Flink = Entry->Flink;
	LIST_ENTRY* Blink = Entry->Blink;
	Blink->Flink = Flink;
	Flink->Blink = Blink;
}
void InsertHeadList(LIST_ENTRY* ListHead, LIST_ENTRY* Entry) {
	LIST_ENTRY* Head = ListHead->Flink;
	Entry->Flink = Head;
	Entry->Blink = ListHead;
	ListHead->Flink = Head->Blink = Entry;
}
void InsertTailList(LIST_ENTRY* ListHead, LIST_ENTRY* Entry) {
	LIST_ENTRY* Tail = ListHead->Blink;
	Entry->Flink = ListHead;
	Entry->Blink = Tail;
	Tail->Flink = ListHead->Blink = Entry;
}
#else //PIECE
void InitializeListHead(LIST_ENTRY* ListHead);
int IsListEmpty(LIST_ENTRY* ListHead);
LIST_ENTRY* RemoveHeadList(LIST_ENTRY* ListHead);
LIST_ENTRY* RemoveTailList(LIST_ENTRY* ListHead);
void RemoveEntryList(LIST_ENTRY* Entry);
void InsertHeadList(LIST_ENTRY* ListHead, LIST_ENTRY* Entry);
void InsertTailList(LIST_ENTRY* ListHead, LIST_ENTRY* Entry);
asm("
		.code
		.align		1
		.global		InitializeListHead
		.global		IsListEmpty
		.global		RemoveHeadList
		.global		RemoveTailList
		.global		RemoveEntryList
		.global		InsertHeadList
		.global		InsertTailList
		;//-------------------------------------;//
InitializeListHead:
		xld.w		[%r12+4], %r12		;//ListHead->Blink = ListHead
		ld.w		[%r12], %r12		;//ListHead->Flink = ListHead
		ret
		;//-------------------------------------;//
IsListEmpty:
		ld.w		%r10, [%r12]		;//%r10    :=  ListHead->Flink
		cmp		%r10, %r12		;//%psr(Z) := (ListHead->Flink == ListHead)	!INTERLOCK!
		ld.w		%r10, %psr		;//%r10[1] := (ListHead->Flink == ListHead)
		ret.d					;//
		and		%r10, 2			;//return     (ListHead->Flink == ListHead)	*delay*		//Cł͔0lƂ1ԂAAsmł͔0lƂ2ԂB0lɈˑȂ悤ӂB
		;//-------------------------------------;//
RemoveHeadList:
		ld.w		%r12, [%r12]		;//%r12 := Head = ListHead->Flink
		jp		RemoveEntryList		;//return RemoveEntryList(Head)					//AsmRemoveEntryList()̉B߂lɈˑ
		;//-------------------------------------;//
RemoveTailList:
		xld.w		%r12, [%r12+4]		;//%r12 := Tail = ListHead->Blink
	;//sv	jp		RemoveEntryList		;//return RemoveEntryList(Tail)					//AsmRemoveEntryList()̉B߂lɈˑ
		;//-------------------------------------;//
RemoveEntryList:
	;//{{C^[bN
	;//	ld.w		%r10, %r12		;//%r10 := Entry
	;//	ld.w		%r11, [%r12]+		;//%r11 := Flink = Entry->Flink
	;//	ld.w		%r12, [%r12]		;//%r12 := Blink = Entry->Blink
	;//	ld.w		[%r12] %r11		;// Blink->Flink = Flink			!INTERLOCK!
	;//	xld.w		[%r11+4], %r12		;// Flink->Blink = Blink
	;//	ret					;//return  Entry						//AsmRemoveEntryList()̉B߂l %r10 := Entry
	;//C^[bN
		ld.w		%r10, %r12		;//%r10 := Entry
		ld.w		%r11, [%r12]+		;//%r11 := Flink = Entry->Flink
		ld.w		%r12, [%r12]		;//%r12 := Blink = Entry->Blink
		xld.w		[%r11+4], %r12		;// Flink->Blink = Blink
		ld.w		[%r12] %r11		;// Blink->Flink = Flink
		ret					;//return  Entry						//AsmRemoveEntryList()̉B߂l %r10 := Entry
	;//}}C^[bN
		;//-------------------------------------;//
InsertHeadList:
	;//{{C^[bN,1ߐߖ
	;//	ld.w		%r9, [%r12]		;//%r9  :=    Head = ListHead->Flink
	;//	ld.w		[%r13], %r9		;//   Entry->Flink = Head			!INTERLOCK!
	;//	xld.w		[%r13+4], %r12		;//   Entry->Blink = ListHead
	;//	xld.w		[%r9+4], %r13		;//    Head->Blink = Entry
	;//	ld.w		[%r12], %r13		;//ListHead->Flink = Entry
	;//	ret
	;//C^[bN,1ߐߖ
		ld.w		%r9, [%r12]		;//%r9  :=    Head = ListHead->Flink
		xld.w		[%r9+4], %r13		;//    Head->Blink = Entry
		ld.w		[%r12], %r13		;//ListHead->Flink = Entry
		ld.w		[%r13]+, %r9		;//   Entry->Flink = Head, %r13 := &Entry->Blink
		ld.w		[%r13], %r12		;//   Entry->Blink = ListHead
		ret
	;//}}C^[bN,1ߐߖ
		;//-------------------------------------;//
InsertTailList:
	;//{{1ߐߖ
	;//	xld.w		%r9, [%r12+4]		;//%r9  :=    Tail = ListHead->Blink
	;//	ld.w		[%r13], %r12		;//   Entry->Flink = ListHead
	;//	xld.w		[%r13+4], %r9		;//   Entry->Blink = Tail
	;//	xld.w		[%r12+4], %r13		;//ListHead->Blink = Entry
	;//	ld.w		[%r9], %r13		;//    Tail->Flink = Entry
	;//	ret
	;//1ߐߖ
		ld.w		[%r13], %r12		;//   Entry->Flink = ListHead
		add		%r12, 4			;//%r12 :=          &ListHead->Blink
		ld.w		%r9, [%r12]		;//%r9  :=    Tail = ListHead->Blink
		xld.w		[%r13+4], %r9		;//   Entry->Blink = Tail
		ld.w		[%r12], %r13		;//ListHead->Blink = Entry
		ld.w		[%r9], %r13		;//    Tail->Flink = Entry
		ret
	;//}}1ߐߖ
");
#endif//PIECE
