/*
 *	cliphfm.h
 *
 *	Canonical Huffman Code
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2014 Naoyuki Sawa
 *
 *	* Fri Nov 21 20:05:45 JST 2014 Naoyuki Sawa
 *	- 1st [XB
 *	- L̋LQlɂ܂B
 *	  uɕ^sŏ璷uCanonical Huffman Codevv(http://codezine.jp/article/detail/376)
 *	  (_E[hāukeep/ɕ^sŏ璷uCanonical Huffman Codev.7zvɕۑĂ܂B)
 *	  ASY͎Qlɂ܂ATv\[X̎͂悭łȂ̂ŁAقڐVKɎ܂B
 *	  Tv\[XAW[̎̕AfR[_̃tbgvgāAP/ECEɓKĂƎv܂B
 *	  ܂AkɊi[镄\ςނ悤Hv̂ŁATv\[XW[̎̕A͂ɈkłB
 *	  ɁATv\[X͌f[^̃TCYwb_Ɋi[Ă܂AW[͏I[Ŕf_ADĂƎv܂B
 *	* Sat Nov 22 10:24:01 JST 2014 Naoyuki Sawa
 *	- kf[^̍쐬́ADOSR}hCc[utool/dphfmv𗘗pĂB
 *	* Sat Nov 22 14:56:38 JST 2014 Naoyuki Sawa
 *	- HuffmanDecoder_Getc()AZu܂B
 *	  HuffmanDecoder_Decode()ŁA39KB˖62KB̓WJs̑xA1.106b˖0.790bɍ܂B(Clock=48MHz,Code=SRAM,Stack=FRAM)
 *	* Sat Nov 22 16:01:39 JST 2014 Naoyuki Sawa
 *	- HuffmanDecoder_Init()AZu܂B
 *	  R[hTCY12oCgȂ܂Bxɂ͂قƂǉe܂B
 *	* Sat Nov 22 17:24:18 JST 2014 Naoyuki Sawa
 *	- HuffmanDecoder_Decode()AZu܂B
 *	  HuffmanDecoder_Decode()ŁA39KB˖62KB̓WJs̑xA0.790b˖0.759bɍ܂B(Clock=48MHz,Code=SRAM,Stack=FRAM)
 *	* Sun Nov 23 01:00:09 JST 2014 Naoyuki Sawa
 *	- cliphfm.cAfR[_[framhfm.cɕ܂B
 *	  P/ECEł̓fR[_[gpȂƂ̂ŁAɃGR[_[Nėeʂ邱Ƃh߂łB
 *	  framhfm.cRAMɔzuāA邱Ƃ\łB
 *	  framhfm.cRAMɔzuƁAHuffmanDecoder_Decode()ŁA39KB˖62KB̓WJs̑xA0.759b˖0.419bɍ܂B(Clock=48MHz,Code=FRAM,Stack=FRAM)
 *	* Sun Nov 23 21:49:53 JST 2014 Naoyuki Sawa
 *	- HuffmanDecoder_Getc()ɁAuHvvZvKp܂B(CłƃAZuł̗)
 *	  HuffmanDecoder_Decode()ŁA39KB˖62KB̓WJs̑xA0.759b˖0.756bɍ܂B(Clock=48MHz,Code=SRAM,Stack=FRAM)
 */
#ifndef __CLIP_HFM_H__
#define __CLIP_HFM_H__

/****************************************************************************
 *	nt}GR[_[
 ****************************************************************************/
//Ŝxňk֐
int HuffmanEncoder_Encode(const void* _src, int srcBytes, void* dst, int dstBytes);

/****************************************************************************
 *	nt}fR[_[
 ****************************************************************************/
//nt}fR[_[\
typedef struct _ST_HuffmanDecoder {	//AZułQƂĂ̂ŃCAEgŒłB
	const void*	src;		//+0,4 \̃AhX
	int		srcPos;		//+4,4 ɓǂݏõrbgʒu	src̑
} ST_HuffmanDecoder;			//=8
/*--------------------------------------------------------------------------*/
//ŜxœWJ֐
int HuffmanDecoder_Decode(const void* src, void* _dst, int dstBytes);
//PoCgÂWJ֐(WJXg[)
void HuffmanDecoder_Init(ST_HuffmanDecoder* pHuffmanDecoder, const void* src);
int HuffmanDecoder_Getc(ST_HuffmanDecoder* pHuffmanDecoder);

#endif//__CLIP_HFM_H__
