/*	
 *	cliplotr.c
 *
 *	I\ROM`
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2015 Naoyuki Sawa
 *
 *	* Wed Feb 18 21:49:13 JST 2015 Naoyuki Sawa
 *	- 1st [XB
 *	- W[́Acliplot.cW[̃bp[Ƃē삵Aȉ̋@\ǉ܂B
 *	  1. I\AAhXłȂI\ԍŎw肷A֐C^[tFCXǉ܂B
 *	  2. eI\̊e̊eIlA񓖑IOƂċL^@\ǉ܂B
 *	     O@\́ALotRom_BeginLog()`LotRom_EndLog()̊Ԃ̂ݗLƂȂ܂B
 *	     LotRom_BeginLog()ĂяoȂ΁A]ȃׂ܂B
 *	* Mon Mar 02 21:47:20 JST 2015 Naoyuki Sawa
 *	- ST_LotRom\̂m_LotTblNo_Max,m_TBL_LotTbltB[h폜܂BLotRom_Init()_LotTblNo_Max폜܂B
 *	  啝ȕύXɂȂ̂ŁAύXÕR[h͎cĂ܂BύXÕR[hԂꍇ́AÕA[JCuQƂĂB
 *	  dLotTblC.exeTBL_LotTblNo[0](LotTblNo_Max+1)i[悤Ȃ̂ŁAAvP[V疾IɎw肷KvȂłB
 *	  ڍׂ/clip/tool/dLotTblC/winapp.h̓̃RgQƂĂB
 */
#include "clip.h"
/****************************************************************************
 *	[Jϐ`
 ****************************************************************************/
static ST_LotRom stLotRom;
/****************************************************************************
 *	[J֐錾
 ****************************************************************************/
static const unsigned short* LotRom_GetLotTbl(int LotTblNo);
#ifdef  USE_LOTROM_LOG
static void LotRom_AddLog(int LotTblNo, const int* pid, int hitval);
#endif//USE_LOTROM_LOG
/****************************************************************************
 *	
 ****************************************************************************/
//I\ԍɑΉAI\ւ̃|C^擾B
static const unsigned short* LotRom_GetLotTbl(int LotTblNo) {
	const int nLotTblNo = stLotRom.m_TBL_LotTblNo[0];				//(I\ԍ̍ől+1)擾B
	const unsigned short* pLotTbl;
	if((LotTblNo < 1) || (LotTblNo >= nLotTblNo)) { DIE(); }			//I\ԍL͈͂ł鎖mFB
	pLotTbl = (const unsigned short*)&stLotRom.m_TBL_LotTblNo[nLotTblNo];		//I\f[^ւ̃|C^߂B(I\AhXe[u̒ɒI\f[^zuO)
	return &pLotTbl[stLotRom.m_TBL_LotTblNo[LotTblNo]];				//I\ւ̃|C^ԂB
}
/*--------------------------------------------------------------------------*/
void LotRom_Init(const int* _TBL_LotTblNo/*[LotTblNo_Max+1]*/, int (*_fnRnd)(/*void* fnRndArg*/), void* _fnRndArg) {
	LotRom_Free();									//ɁAI\ROMǗJnĂAUAI\ROMǗIB
	stLotRom.m_TBL_LotTblNo	= _TBL_LotTblNo;					//I\AhXe[uւ̃|C^i[B
	stLotRom.m_fnRnd	= _fnRnd;						//WFl[^֐ւ̃|C^i[B
	stLotRom.m_fnRndArg	= _fnRndArg;						//WFl[^֐ւ̈i[B
}
/*--------------------------------------------------------------------------*/
//I\ROMǗIB
void LotRom_Free() {
#ifdef  USE_LOTROM_LOG
	LotRom_EndLog();								//mɁAOIB
#endif//USE_LOTROM_LOG
	memset(&stLotRom, 0, sizeof stLotRom);						//I\ROMǗNAB
}
/*--------------------------------------------------------------------------*/
//I\́Aw肳ꂽIpāAIs܂B
int LotRom_draw_v(int LotTblNo, const int* pid) {
	int retval = LOT_draw_table_v(LotRom_GetLotTbl(LotTblNo), pid, (unsigned short)(*stLotRom.m_fnRnd)(stLotRom.m_fnRndArg));	//WFl[^֐32bitԂĂǂB֐16bitɐ؂l߂B
#ifdef  USE_LOTROM_LOG
	LotRom_AddLog(LotTblNo, pid, retval);						//I\ROMǗJnĂAIʂOɋL^B
#endif//USE_LOTROM_LOG
	return retval;
}
int LotRom_draw_a(int LotTblNo, va_list ap) {
	int id[(7+1)/**/], i = 0;							//pAIids7ȉ(I[܂8ȉ)ƍlď[낤Bsꍇ͑₹B
	for(;;) {
		if((id[i] = va_arg(ap, int)) == -1) { break; }
		if(++i >= ARRAY_SIZE(id)) { DIE(); }					//Œ~ꍇ́Aid[]s,,ďoI[YĂB炭҂낤B
	}
	return LotRom_draw_v(LotTblNo, id);						//O͂̒ōsB
}
int LotRom_draw_l(int LotTblNo, ...) {
	int retval;
	va_list ap;
	va_start(ap, LotTblNo);
	retval = LotRom_draw_a(LotTblNo, ap);						//O͂̒ōsB
	va_end(ap);
	return retval;
}
/*--------------------------------------------------------------------------*/
//I\́Aw肳ꂽÍAw肳ꂽIĺAdݒl擾܂B
int LotRom_get_weight_v(int LotTblNo, const int* pid, int hitval_sel) {
	return LOT_get_table_weight_v(LotRom_GetLotTbl(LotTblNo), pid, hitval_sel);
}
int LotRom_get_weight_a(int LotTblNo, va_list ap, int hitval_sel) {
	return LOT_get_table_weight_a(LotRom_GetLotTbl(LotTblNo), ap, hitval_sel);
}
int LotRom_get_weight_l(int LotTblNo, int hitval_sel, ...) {
	int retval;
	va_list ap;
	va_start(ap, hitval_sel);
	retval = LotRom_get_weight_a(LotTblNo, ap, hitval_sel);
	va_end(ap);
	return retval;
}
/*--------------------------------------------------------------------------*/
//I\́A񐔂擾܂B
int LotRom_get_size(int LotTblNo) {
	return LOT_get_table_size(LotRom_GetLotTbl(LotTblNo));
}
/*--------------------------------------------------------------------------*/
//I\́AIids擾܂B
int LotRom_get_id_size(int LotTblNo) {
	return LOT_get_table_id_size(LotRom_GetLotTbl(LotTblNo));
}
/*--------------------------------------------------------------------------*/
//I\́A(i_column)Ԗڂ̒ÍAid̑g擾܂B
void LotRom_get_column_id(int LotTblNo, int i_column, int* pid) {
	LOT_get_table_column_id(LotRom_GetLotTbl(LotTblNo), i_column, pid);
}
/****************************************************************************
 *	O@\
 ****************************************************************************/
#ifdef  USE_LOTROM_LOG
//I\O
typedef struct _ST_LotRom_TblLog {
	struct _ST_LotRom_ColLog*	TBL_ColLog/*[I\̗]*/;			//I񃍃O
} ST_LotRom_TblLog;
//I񃍃O
typedef struct _ST_LotRom_ColLog {
	unsigned			    LotCnt;					//I
	unsigned*			TBL_HitCnt/*[I̗vf]*/;			//I	(LotCnt-SUM(TBL_HitCnt))=񓖑I
} ST_LotRom_ColLog;
/*--------------------------------------------------------------------------*/
//OJnB
void LotRom_BeginLog() {
	const int nLotTblNo = stLotRom.m_TBL_LotTblNo[0];				//(I\ԍ̍ől+1)擾B
	int LotTblNo, table_size, id_size, i_column, column_size;
	LotRom_EndLog();								//ɁAOJnĂAUAOIB
	stLotRom.m_TBL_TblLog = calloc(nLotTblNo, sizeof(ST_LotRom_TblLog*));		//I\ÕmۂB
	if(!stLotRom.m_TBL_TblLog) { DIE(); }						//s
	for(LotTblNo = 1; LotTblNo < nLotTblNo; LotTblNo++) {
		ST_LotRom_TblLog* pTblLog = &stLotRom.m_TBL_TblLog[LotTblNo];
		const unsigned short* table = LotRom_GetLotTbl(LotTblNo);
		table_size = *table++;							//I\̗
		id_size    = *table++;							//Iids
		pTblLog->TBL_ColLog = calloc(table_size, sizeof(ST_LotRom_ColLog));	//I񃍃ÕmۂB
		if(!pTblLog->TBL_ColLog) { DIE(); }					//s
		for(i_column = 0; i_column < table_size; i_column++) {
			ST_LotRom_ColLog* pColLog = &pTblLog->TBL_ColLog[i_column];
			table += id_size;						//Iid
			column_size = *table++;						//I̗vf
			table += column_size * 2/*{hitval,weight}*/;			//I̗vf
			pColLog->TBL_HitCnt = calloc(column_size, sizeof(unsigned));	//I񐔂̃mۂB
			if(!pColLog->TBL_HitCnt) { DIE(); }				//s
		}
	}
}
/*--------------------------------------------------------------------------*/
//Oo͂B
void LotRom_DumpLog() {
	const int nLotTblNo = stLotRom.m_TBL_LotTblNo[0];				//(I\ԍ̍ől+1)擾B
	int LotTblNo, table_size, id_size, i_column, column_size, i;
	if(!stLotRom.m_TBL_TblLog) { DIE(); }						//OJnĂȂɁA֐ĂяoĂ͂ȂB
	for(LotTblNo = 1; LotTblNo < nLotTblNo; LotTblNo++) {
		ST_LotRom_TblLog* pTblLog = &stLotRom.m_TBL_TblLog[LotTblNo];
		const unsigned short* table = LotRom_GetLotTbl(LotTblNo);
		table_size = *table++;							//I\̗
		id_size    = *table++;							//Iids
		for(i_column = 0; i_column < table_size; i_column++) {
			ST_LotRom_ColLog* pColLog = &pTblLog->TBL_ColLog[i_column];
			table += id_size;						//Iid
			column_size = *table++;						//I̗vf
			printf("%d", pColLog->LotCnt);					//o:I
			for(i = 0; i < column_size; i++) {
				printf("\t%d\t%d", *table, pColLog->TBL_HitCnt[i]);	//o:(TAB)Il(TAB)I
				table += 2/*{hitval,weight}*/;				//vf΂B
			}
			printf("\n");							//o:Ỉs
		}
		if(LotTblNo != (nLotTblNo - 1)) { printf("\n"); }			//o:I\ƒI\̊Ԃ̋s
	}
}
/*--------------------------------------------------------------------------*/
//OIB
void LotRom_EndLog() {
	const int nLotTblNo = stLotRom.m_TBL_LotTblNo[0];				//(I\ԍ̍ől+1)擾B
	if(stLotRom.m_TBL_TblLog) {		//OJnĂc
		int LotTblNo, table_size, id_size, i_column, column_size;
		for(LotTblNo = 1; LotTblNo < nLotTblNo; LotTblNo++) {
			ST_LotRom_TblLog* pTblLog = &stLotRom.m_TBL_TblLog[LotTblNo];
			const unsigned short* table = LotRom_GetLotTbl(LotTblNo);
			table_size = *table++;						//I\̗
			id_size    = *table++;						//Iids
			for(i_column = 0; i_column < table_size; i_column++) {
				ST_LotRom_ColLog* pColLog = &pTblLog->TBL_ColLog[i_column];
				table += id_size;					//Iid
				column_size = *table++;					//I̗vf
				table += column_size * 2/*{hitval,weight}*/;		//I̗vf
				free(pColLog->TBL_HitCnt);				//I񐔂̃JB
			}
			free(pTblLog->TBL_ColLog);					//I񃍃ÕJB
		}
		free(stLotRom.m_TBL_TblLog);						//I\ÕJB
		stLotRom.m_TBL_TblLog = NULL;						//OJnĂȂB
	}
}
/*--------------------------------------------------------------------------*/
//IʂOɋL^B
static void LotRom_AddLog(int LotTblNo, const int* pid, int hitval) {
	if(stLotRom.m_TBL_TblLog) {		//OJnĂc
		ST_LotRom_TblLog* pTblLog = &stLotRom.m_TBL_TblLog[LotTblNo];		//I\Oւ̃|C^擾B
		ST_LotRom_ColLog* pColLog = pTblLog->TBL_ColLog;			//ŏ̗̒I񃍃Oւ̃|C^擾B
		const unsigned short* table = LotRom_GetLotTbl(LotTblNo);		//I\ԍɑΉAI\ւ̃|C^擾B
	    //{{͈̔͂cliplot.cLOT_seek_and_call()ƂقړASYłBẽRgLOT_seek_and_call()QƂĂB
		int table_size, id_size, column_size, n_id, diff;
		table_size = *table++;							//I\̗
		id_size    = *table++;							//Iids
		for(;;) {
			if(--table_size < 0) { DIE(); }					//w肳ꂽid̑gI񂪌ȂB	LOT_draw_table_v()̂ɂŎs鎖͖͂BŒ~oOłB(f[^oOł͂ȂW[PGoOł\)
			n_id = id_size;							//IidrB
			diff = 0;
			while(--n_id >= 0) { diff |= (*table++ - *pid++); }
			column_size = *table++;						//I̗vf
			if(!diff) { break; }						//w肳ꂽid̑gI񂪌AB
			pid -= id_size;							//w肳ꂽid̑g̃|C^߂B
			table += column_size * 2/*{hitval,weight}*/;			//I΂B
			pColLog++;							//I񃍃Oւ̃|C^̗֐i߂B
		}
		if(*pid != -1) { DIE(); }						//w肳ꂽIid̑ǵAI[mFB	LOT_draw_table_v()̂ɂŎs鎖͖͂BŒ~oOłB(f[^oOł͂ȂW[PGoOł\)
	    //}}͈̔͂cliplot.cLOT_seek_and_call()ƂقړASYłBẽRgLOT_seek_and_call()QƂĂB
		pColLog->LotCnt++;							//I񐔂𑝂₷B
		if(hitval != -1) {							//񓖑IłȂ΁c
			unsigned* pHitCnt = pColLog->TBL_HitCnt;			//ŏ̗vf̓I񐔂ւ̃|C^擾B
			for(;;) {
				if(--column_size < 0) { DIE(); }			//w肳ꂽIlvfȂB		LOT_draw_table_v()ÎɂŎs鎖͖͂BŒ~oOłB(f[^oOł͂ȂW[PGoOł\)
				if(*table == hitval) { break; }				//w肳ꂽIlvfAB
				table += 2/*{hitval,weight}*/;				//vf΂B
				pHitCnt++;						//I񐔂ւ̃|C^̗vf֐i߂B
			}
			(*pHitCnt)++;							//I񐔂𑝂₷B
		}
	}
}
#endif//USE_LOTROM_LOG
